'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function handleStatus(response) {
  if (response.status >= 200 && response.status < 300) {
    return response;
  } else {
    var error = new Error(response.statusText);
    error.response = response;
    throw error;
  }
}

var rxOne = /^[\],:{}\s]*$/;
var rxTwo = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g;
var rxThree = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g;
var rxFour = /(?:^|:|,)(?:\s*\[)+/g;
var isJSON = function isJSON(input) {
  return input.length && rxOne.test(input.replace(rxTwo, '@').replace(rxThree, ']').replace(rxFour, ''));
};

function parse(response) {
  return response.text().then(function (text) {
    return isJSON(text) ? JSON.parse(text) : {};
  });
}

//TODO: Add custom fetch support with subclassing

var APIAdapter = function () {
  function APIAdapter(config) {
    _classCallCheck(this, APIAdapter);

    this.globalOptions = config.globalOptions;
  }

  _createClass(APIAdapter, [{
    key: 'fetch',
    value: function (_fetch) {
      function fetch(_x, _x2, _x3, _x4, _x5) {
        return _fetch.apply(this, arguments);
      }

      fetch.toString = function () {
        return _fetch.toString();
      };

      return fetch;
    }(function (path, method, fetchOptions, handler, errorHandler) {
      var finalOptions = _lodash2.default.merge({}, this.globalOptions, fetchOptions);
      var params = finalOptions.params;

      if (params && !_lodash2.default.isEmpty(params)) {
        path = path + '?' + _queryString2.default.stringify(params);
        delete fetchOptions.params;
      }
      console.log('calling with options ', finalOptions, fetchOptions);
      finalOptions.method = method;
      return fetch(path, finalOptions).then(handleStatus).then(parse).then(handler).catch(errorHandler);
    })
  }]);

  return APIAdapter;
}();

exports.default = APIAdapter;