'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function template(str, data) {
  data = data || {};

  var matcher = str.match(/{(.+?)}/g);
  if (!matcher) return str;

  matcher.forEach(function (key) {
    str = str.replace(key, data[key.replace('{', '').replace('}', '')]);
  });
  return str;
}

var RequestResolver = function () {
  function RequestResolver(config) {
    _classCallCheck(this, RequestResolver);

    this.globalOptions = config.globalOptions;
  }

  _createClass(RequestResolver, [{
    key: 'resolveRouteParams',
    value: function resolveRouteParams(model, routeParams) {
      console.log('Resolving Route: ', model, routeParams);
      return template(model.apiPath, routeParams);
    }
  }, {
    key: 'create',
    value: function create(data, requestOptions) {
      //{params, body, headers}
      return {
        url: requestOptions.apiPath,
        method: 'POST',
        options: {
          body: JSON.stringify(data)
        }
      };
    }
  }, {
    key: 'update',
    value: function update(id, data, requestOptions) {
      return {
        url: requestOptions.apiPath + '/' + id,
        method: 'PATCH',
        options: {
          body: JSON.stringify(data)
        }
      };
    }
  }, {
    key: 'updateAll',
    value: function updateAll(where, data, requestOptions) {
      var params = { where: JSON.stringify(where) };
      var body = JSON.stringify(data);

      return {
        url: requestOptions.apiPath + '/update',
        method: 'POST',
        options: { params: params, body: body }
      };
    }
  }, {
    key: 'find',
    value: function find(filter, requestOptions) {
      var params = { filter: JSON.stringify(filter) };
      return {
        url: requestOptions.apiPath,
        method: 'GET',
        options: { params: params }
      };
    }
  }, {
    key: 'findById',
    value: function findById(id, filter, requestOptions) {
      var params = filter ? { filter: JSON.stringify(filter) } : null;
      return {
        url: requestOptions.apiPath + '/' + id,
        method: 'GET',
        options: { params: params }
      };
    }
  }, {
    key: 'deleteById',
    value: function deleteById(id, requestOptions) {
      return {
        url: requestOptions.apiPath + '/' + id,
        method: 'DELETE',
        options: {}
      };
    }
  }, {
    key: 'count',
    value: function count(where, requestOptions) {
      var params = { where: JSON.stringify(where) };
      return {
        url: requestOptions.apiPath + '/count',
        method: 'GET',
        options: { params: params }
      };
    }
  }, {
    key: 'custom',
    value: function custom(name, path, method) {
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
      var requestOptions = arguments[4];

      var _options = { headers: options.headers };
      if (options.params) _options.params = _lodash2.default.mapValues(options.params, function (value) {
        if (_lodash2.default.isObject(value)) {
          return JSON.stringify(value);
        }
        return value;
      });
      if (options.body) _options.body = JSON.stringify(options.body);

      return {
        url: requestOptions.apiPath + '/' + path,
        method: method,
        options: _options
      };
    }
  }]);

  return RequestResolver;
}();

exports.default = RequestResolver;