'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var paging = function paging(list, routeParams, props) {
  return function (Component) {
    var actions = list.actions(routeParams);
    var selectors = list.selectors(routeParams);

    var mapStateToProps = function mapStateToProps(state) {
      return {
        instances: selectors.getInstances(state),
        pages: selectors.getPages(state),
        currentPage: selectors.getCurrentPage(state),
        total: selectors.getTotal(state),
        hasNext: selectors.hasNext(state),
        hasPrev: selectors.hasPrev(state),
        pageSize: selectors.getPageSize(state)
      };
    };
    var mapDispatchToProps = function mapDispatchToProps(dispatch) {
      return {
        gotoPage: function gotoPage(page) {
          return dispatch(actions.page(page));
        },
        first: function first() {
          return dispatch(actions.first());
        },
        last: function last() {
          return dispatch(actions.last());
        },
        next: function next() {
          return dispatch(actions.next());
        },
        prev: function prev() {
          return dispatch(actions.prev());
        },
        refresh: function refresh() {
          return dispatch(actions.refresh());
        },
        setOptions: function setOptions(options) {
          return dispatch(actions.setOptions(options));
        },
        setParams: function setParams(params) {
          return dispatch(actions.setParams(params));
        }
      };
    };

    var ListHoc = function (_React$Component) {
      _inherits(ListHoc, _React$Component);

      function ListHoc() {
        _classCallCheck(this, ListHoc);

        return _possibleConstructorReturn(this, (ListHoc.__proto__ || Object.getPrototypeOf(ListHoc)).apply(this, arguments));
      }

      _createClass(ListHoc, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.props, props));
          // restActions={actions}
        }
      }]);

      return ListHoc;
    }(_react2.default.Component);

    return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(ListHoc);
  };
};

exports.default = paging;