'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.paging = exports.connectModel = exports.DEFAULT_CONFIG = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

require('whatwg-fetch');

var _ApiAdapter = require('./adapter/ApiAdapter');

var _ApiAdapter2 = _interopRequireDefault(_ApiAdapter);

var _RequestAdapter = require('./adapter/RequestAdapter');

var _RequestAdapter2 = _interopRequireDefault(_RequestAdapter);

var _createReducer2 = require('./createReducer');

var _createReducer3 = _interopRequireDefault(_createReducer2);

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

var _paging = require('./hoc/paging');

var _paging2 = _interopRequireDefault(_paging);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DEFAULT_CONFIG = exports.DEFAULT_CONFIG = {
  models: [],
  globalOptions: {
    params: null,
    headers: null,
    body: null
  },
  rootSelector: function rootSelector(state) {
    return state.rest;
  }
};

var Wrapper = function () {
  function Wrapper(_config) {
    var _this = this;

    _classCallCheck(this, Wrapper);

    this.config = _lodash2.default.merge({}, DEFAULT_CONFIG, _config);
    var models = this.config.models;

    console.log('config set: ', this.config);
    this.reducer = (0, _createReducer3.default)(models);
    this.middleware = function (store) {
      return function (next) {
        return function (action) {
          return next(action);
        };
      };
    };
    var apiAdapter = new _ApiAdapter2.default(this.config);
    var requestAdapter = new _RequestAdapter2.default(this.config);
    this._models = _lodash2.default.keyBy(_lodash2.default.map(models, function (model) {
      return new _model2.default(model, _this.config, apiAdapter, requestAdapter);
    }), 'modelName');
  }

  _createClass(Wrapper, [{
    key: 'get',
    value: function get(modelName) {
      return this._models[modelName];
    }
  }, {
    key: 'updateGlobal',
    value: function updateGlobal(options) {
      _lodash2.default.merge(this.config.globalOptions, options);
    }
  }, {
    key: 'clear',
    value: function clear(dispatch) {
      _lodash2.default.each(this._models, function (model) {
        return dispatch(model.actions.clear());
      });
    }

    // createModelWrapper(model) {
    //   const modelWrapper =
    //    {
    //     modelName: model.modelName,
    //     actions: new ModelActions(model, this.config, this.apiAdapter),
    //     selectors: modelSelectors(model, this.config.rootSelector),
    //     createList: name => {
    //       return {
    //         name: name,
    //         actions: new ListActions()
    //       }
    //     }
    //   }
    // }

  }]);

  return Wrapper;
}();

exports.default = Wrapper;
var connectModel = exports.connectModel = function connectModel(model, filter) {
  return function (Component) {
    //const actions = createActions(model)
    // QUESTION:?? Get filtered action here const instances = actions.find()
    return function (_React$Component) {
      _inherits(ModelComponent, _React$Component);

      function ModelComponent() {
        _classCallCheck(this, ModelComponent);

        return _possibleConstructorReturn(this, (ModelComponent.__proto__ || Object.getPrototypeOf(ModelComponent)).apply(this, arguments));
      }

      _createClass(ModelComponent, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, this.props);
          // restActions={actions}
        }
      }]);

      return ModelComponent;
    }(_react2.default.Component);
  };
};

var paging = exports.paging = _paging2.default;