'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SET_OPTIONS = _constants.LIST.SET_OPTIONS,
    PAGE = _constants.LIST.PAGE,
    FIRST = _constants.LIST.FIRST,
    NEXT = _constants.LIST.NEXT,
    LAST = _constants.LIST.LAST,
    PREV = _constants.LIST.PREV,
    SET_PARAMS = _constants.LIST.SET_PARAMS;

var ListActions = function () {
  function ListActions(listName, listSelectors, model, modelActions) {
    _classCallCheck(this, ListActions);

    this.modelActions = modelActions;
    this.listSelectors = listSelectors;
    this.listName = listName;
    this.modelName = model.modelName;
  }

  _createClass(ListActions, [{
    key: 'setOptions',
    value: function setOptions(_ref) {
      var headers = _ref.headers,
          params = _ref.params,
          pageSize = _ref.pageSize,
          offset = _ref.offset;

      var payload = _lodash2.default.omitBy({ headers: headers, params: params, pageSize: pageSize, offset: offset, listName: this.listName, modelName: this.modelName }, _lodash2.default.isNil);
      return { type: SET_OPTIONS, payload: payload };
    }
  }, {
    key: 'setParams',
    value: function setParams(params) {
      var payload = _lodash2.default.omitBy(_extends({}, params, { listName: this.listName, modelName: this.modelName }), _lodash2.default.isNil);
      return { type: SET_PARAMS, payload: payload };
    }
  }, {
    key: '_page',
    value: function _page(page, dispatch, state) {
      dispatch({ type: PAGE, payload: { page: page, listName: this.listName, modelName: this.modelName } });
      var listObj = this.listSelectors.getListObj(state);
      var _listObj$params = listObj.params,
          where = _listObj$params.where,
          include = _listObj$params.include;

      var filter = _lodash2.default.omitBy({ where: where, limit: listObj.pageSize, skip: page * listObj.pageSize, include: include }, _lodash2.default.isNil);

      dispatch(this.modelActions.find(filter, this.listName));
      dispatch(this.modelActions.count(where, this.listName));
    }
  }, {
    key: 'page',
    value: function page(_page2) {
      var _this = this;

      return function (dispatch, getState) {
        return _this._page(_page2, dispatch, getState());
      };
    }
  }, {
    key: 'next',
    value: function next() {
      var _this2 = this;

      return function (dispatch, getState) {
        var hasNext = _this2.listSelectors.hasNext(getState());
        if (hasNext) {
          var currentPage = _this2.listSelectors.getCurrentPage(getState());
          return _this2._page(currentPage + 1, dispatch, getState());
        }
      };
    }
  }, {
    key: 'prev',
    value: function prev() {
      var _this3 = this;

      return function (dispatch, getState) {
        var hasPrev = _this3.listSelectors.hasPrev(getState());
        if (hasPrev) {
          var currentPage = _this3.listSelectors.getCurrentPage(getState());
          return _this3._page(currentPage - 1, dispatch, getState());
        }
      };
    }
  }, {
    key: 'refresh',
    value: function refresh() {
      var _this4 = this;

      return function (dispatch, getState) {
        var currentPage = _this4.listSelectors.getCurrentPage(getState());
        return _this4._page(currentPage, dispatch, getState());
      };
    }
  }, {
    key: 'first',
    value: function first() {
      var _this5 = this;

      return function (dispatch, getState) {
        var hasPrev = _this5.listSelectors.hasPrev(getState());
        if (hasPrev) {
          return _this5._page(0, dispatch, getState());
        }
      };
    }
  }, {
    key: 'last',
    value: function last() {
      var _this6 = this;

      return function (dispatch, getState) {
        var state = getState();
        var hasNext = _this6.listSelectors.hasNext(state);
        if (hasNext) {
          var pageSize = _this6.listSelectors.getListObj(state).pageSize;
          var total = _this6.listSelectors.getTotal(state);
          return _this6._page(Math.floor(total / pageSize), dispatch, state);
        }
      };
    }
  }]);

  return ListActions;
}();

exports.default = ListActions;