'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (list, modelSelectors) {

  var getListObj = function getListObj(state) {
    return modelSelectors.getModelObj(state).lists[list];
  };

  var getTotal = function getTotal(state) {
    return getListObj(state).total;
  };

  var getInstances = function getInstances(state) {
    var result = getListObj(state).result;
    //modelSelectors.getInstances() won't work, as it returns Array, instead of Object Map
    var instances = modelSelectors.getModelObj(state).instances;
    return _lodash2.default.map(result, function (id) {
      return instances[id];
    });
  };

  var getCurrentPage = function getCurrentPage(state) {
    var listObj = getListObj(state);
    return Math.ceil(listObj.offset / listObj.pageSize);
  };

  var getPages = function getPages(state) {
    var listObj = getListObj(state);
    var pages = Math.ceil(listObj.total / listObj.pageSize);
    return [].concat(_toConsumableArray(Array(pages))).map(function (_, i) {
      return i++;
    });
  };
  var hasNext = function hasNext(state) {
    var listObj = getListObj(state);
    return listObj.offset + listObj.pageSize < listObj.total;
  };

  var hasPrev = function hasPrev(state) {
    return getListObj(state).offset > 0;
  };

  var getPageSize = function getPageSize(state) {
    var listObj = getListObj(state);
    return listObj.pageSize;
  };

  return {
    getListObj: getListObj, getInstances: getInstances, getTotal: getTotal, getPages: getPages, getCurrentPage: getCurrentPage, hasNext: hasNext, hasPrev: hasPrev, getPageSize: getPageSize
  };
};