'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ModelActions = require('./ModelActions');

var _ModelActions2 = _interopRequireDefault(_ModelActions);

var _modelSelectors = require('./modelSelectors');

var _modelSelectors2 = _interopRequireDefault(_modelSelectors);

var _list = require('../list');

var _list2 = _interopRequireDefault(_list);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Model = function () {
  function Model(model, config, apiAdapter, requestAdapter) {
    var _this = this;

    _classCallCheck(this, Model);

    model.apiPath = model.apiPath ? config.basePath + model.apiPath : config.basePath + '/' + model.modelName;

    this.modelName = model.modelName;
    this.config = config;
    this.actions = function (routeParams) {
      return new _ModelActions2.default(model, config, routeParams, apiAdapter, requestAdapter);
    };
    this.selectors = function (routeParams) {
      return (0, _modelSelectors2.default)(model, routeParams, config.rootSelector);
    };
    this.lists = {};
    if (model.lists) {
      model.lists.forEach(function (list) {
        return _this.lists[list.name] = _this.createList(list);
      });
    }
  }

  _createClass(Model, [{
    key: 'createList',
    value: function createList(_ref) {
      var name = _ref.name,
          options = _ref.options;

      return new _list2.default(name, this, options);
    }
  }]);

  return Model;
}();

exports.default = Model;