'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (model, routeParams, rootSelector) {
  var getModelObj = function getModelObj(state) {
    return rootSelector(state)[model.modelName];
  };
  var getInstances = function getInstances(state) {
    return _lodash2.default.values(rootSelector(state)[model.modelName].instances);
  };
  var isLoading = function isLoading(state) {
    return rootSelector(state)[model.modelName].request.loading;
  };
  var getCount = function getCount(state) {
    return rootSelector(state)[model.modelName].last.count;
  };
  var getFound = function getFound(state) {
    var found = rootSelector(state)[model.modelName].last.find;
    var instances = rootSelector(state)[model.modelName].instances;
    return _lodash2.default.map(found, function (id) {
      return instances[id];
    });
  };

  return {
    getModelObj: getModelObj, getInstances: getInstances, isLoading: isLoading, getCount: getCount, getFound: getFound
  };
};